/**
 Copyright (c) 2016 ETH Zurich, 2004-2016 Oliver Hilsenbeck, Bernhard Schauberger, Stavroula Skylaki, Timm Schroeder
  
 This file is part of "The Tracking Tool" (tTt).
  
 tTt is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef treefragment_h__
#define treefragment_h__

// Project
#include "treefragmenttrack.h"
#include "treefragmenttrackpoint.h"
#include "tttdata/tree.h"
#include "itree.h"

// Qt
#include <QSharedPointer>
#include <QList>
#include <QHash>

/**
 * Represents one tree that has been generated by an external autotracking tool.
 * As autotracking takes place outside of tTt, this class is read-only. TreeFragments can be read from files and be converted to
 * regular Trees, but they cannot be changed.
 *
 * This class does not support copying or = assignments
 */

class TreeFragment : public ITree {

public:

	/**
	 * Create tree fragment by reading it from specified file. Throws TTTException in case of error
	 * @param _fileName input filename
	 * @param _trackpointsHash hashmap to store trackpoints by timepoint or 0
	 * @param _doNotSaveInHash if trackpoints should not be saved in _trackpointsHash
	 */
	TreeFragment( const QString& _fileNameWithPath, QHash<int, QList<QSharedPointer<TreeFragmentTrackPoint>>>& _trackpointsHash, bool _doNotSaveInHash = false );

	/**
	 * Create an empty tree fragment with specified number and fileName as source.
	 */
	TreeFragment( const QString& _fileNameWithPath, int _treeFragmentNumber, int _positionNumber);
	
	~TreeFragment() {

	}

	/**
	 * Convert treefragment to a regular tree
	 * @return pointer to regular tree. Ownership is handed over to caller
	 */
	QSharedPointer<Tree> convertToTree(int _maxTimePoint) const;

	/**
	 * Get position number where this tree starts
	 * @return position number as integer
	 */
	int getPositionNumber() const;

	/**
	 * @return if this tree is finished, i.e. was already added to a tree
	 */
	bool isUsedForTTTTree() const { 
		return !associatedTree.isEmpty() && associatedTree != "*"; 
	}

	///**
	// * @return name of this tree fragment
	// */
	//QString getName() const;

	/**
	 * @return pointer to root node
	 */
	TreeFragmentTrack* getRootNode() const {
		return root.data();
	}

	/**
	 * Create new track and return pointer to it. Fails if track already exists or if no parent track exists (unless track is root).
	 */
	TreeFragmentTrack* insertTrack(int trackNumber, int startTp, int stopTp, QHash<int, QSharedPointer<TreeFragmentTrackPoint>>&& trackPoints);

	/**
	 * @return track by track number or 0 if no such track exists
	 */
	TreeFragmentTrack* getTrackByNumber(int _number) const;

	/**
	 * @return number of tracks
	 */
	int getNumberOfTracks() const {
		return tracks.size();
	}

	/**
	 * @return max track number
	 */
	int getMaxTrackNumber() const {
		return maxTrackNumber;
	}

	/**
	 * @return tree name. This is usually the TreeFragment's filename (which can be empty), except if a treeName hast
	 * been set via setTreeName that is not empty
	 */
	QString getTreeName() const {
		// Check if we have a tree name
		if(!treeName.isEmpty())
			return treeName;
		return fileName;
	}

	/**
	 * Get trackpoints at specified timepoint
	 * @param _timePoint the timepoint
	 * @return list of pointers to ITrackPoint objects (remain valid only as long as tree object exists)
	 */
	QList<ITrackPoint*> getTrackPointsAtTimePoint(int _timePoint) const;

	/**
	 * @return name of associated tree or empty string if not set or string containing only "*" if fragment has been marked as invalid
	 */
	QString getAssociatedTreeName() const {
		return associatedTree;
	}

	/**
	 * Set name of associated tree
	 * @param _name filename without path of tree
	 */
	void setAssociatedTree(const QString& _name) {
		associatedTree = _name;
	}

	/**
	 * @return if treefragment has been marked as invalid
	 */
	bool isInvalid() const {
		return (associatedTree == "*");
	}

	/**
	 * Mark tree fragment as invalid
	 * Sets associatedTree to "*"
	 */
	void markAsInvalid() {
		associatedTree = "*";
	}

	/**
	 * Write name of tree associated with this fragment or if fragment is invalid to log file
	 * @return true if successful
	 */
	bool writeAssociatedTreeToFile() const;

	/**
	 * @return number of this tree fragment
	 */
	int  getTreeFragmentNumber() const {
		return treeFragmentNumber;
	}

	/**
	 * Set tree name
	 * @param _name the new tree name, can be empty
	 */
	void setTreeName(const QString& _name) {
		treeName = _name;
	}

	/**
	 * @return number of trackpoints in this tree
	 */
	int getNumberOfTrackPoints() const {
		return numberOfTrackPoints;
	}

	/**
	 * @return modified state, reimplemented from ITree (returns always false since TreeFragments cannot be modified in tTt)
	 */
	bool getModified() const {
		return false;
	}

	///**
	// * Read name of tree associated with this fragment from log file
	// * @return true if successful
	// */
	//bool readAssociatedTreeFromFile();

	/**
	 * @return first timepoint
	 */
	int getFirstTimePoint() const {
		return firstTimePoint;
	}

	/**
	 * @return absolute file name
	 */
	QString getFilename() const {
		return fileName;
	}

	/**
	 * Set weak pointer instance to this class in all tracks 
	 * @param weakPointer the shared pointer instance
	 */
	void setWeakPointer(QWeakPointer<TreeFragment> weakPointer);

	///**
	// * Clear shared pointer instances to this class in all tracks
	// */
	//void clearSharedPointers() const;

	/**
	 * @return const reference to all tracks
	 */
	const QHash<int, QSharedPointer<TreeFragmentTrack> >& getAllTracks() const {
		return tracks;
	}

	/**
	 * Get a specific property of this tree
	 */
	QVariant getTreeProperty(QString _propName) const;

	/**
	 * Get a list of all possible properties.
	 * The returned values are suitable arguments for getTreeProperty
	 */
	QVector<QString> getAvailableProperties() const;

	/**
	 * Prepend another tree fragment to the root track of this fragment.
	 * @param other pointer to tree fragment that should be prepended. Will not be changed if function fails. If function
	 *        is successful, it will be deleted automatically, unless deleteOther is false, then it will be empty.
	 * @param trackNum track number of other tree fragment where this tree fragment should be appended.
	 * @param deleteOther if other should be deleted automatically, if function was successful. 
	 * @return true if successful.
	 */
	bool prependFragment(TreeFragment* other, int trackNum, bool deleteOther = true);

	/**
	 * Save to file. Throws in case of error.
	 * @param fileName  file name.
	 */
	void exportToFile(const QString& _fileName) const;

	// trf file version
	static const unsigned int TRF_FILE_VERSION = 2;

private:

	// Recursive convert to tree helper function
	void convertToTreeRec(Tree* _tree, Track* _parentTrack, TreeFragmentTrack *_track, int _maxTimePoint) const;

	// Return filename of corresponding log file or empty string in case of error
	QString getLogFileName() const;

	// Export _track and its children if present (recursive)
	void exportTrackToFile(QDataStream& _out, TreeFragmentTrack* _track, quint64 _trackNumber) const;

	// Root track
	QSharedPointer<TreeFragmentTrack> root;

	// Tracks by track numbers
	QHash<int, QSharedPointer<TreeFragmentTrack> > tracks;

	// If this TreeFragment was appended into a regular tree and that tree has been saved, this string contains the name of that tree
	QString associatedTree;

	// Position number
	int positionNumber;

	// Path of file (with '/' at end)
	QString path;

	// Tree fragment filename (without path)
	QString fileName;

	// Tree name, usually empty
	QString treeName;

	// Tree fragment number
	int treeFragmentNumber;

	// Max tracknumber
	int maxTrackNumber;

	// Number of trackpoints
	int numberOfTrackPoints;

	// First timepoint (i.e. smallest timepoint)
	int firstTimePoint;

	// Additional (arbitrary) data columns (per track point, each TreeFragmentTrackPoint contains corresponding double vector)
	QVector<QString> additionalAttributes;

	// File version
	static const unsigned int FILE_VERSION = 2;

	// Forbidden
	TreeFragment(const TreeFragment&);
	TreeFragment& operator=(const TreeFragment&);

	friend TreeFragmentTrack;
};


#endif // treefragment_h__
